/// <reference types="codemirror" />
/// <reference types="react" />
import { IProps } from './common/props';
import { ICodeMirror } from './components/CodeMirror';
import { MarkdownPreviewProps } from '@uiw/react-markdown-preview';
import { IToolBarProps } from './components/ToolBar';
import './index.less';
export * from './commands';
export interface IMarkdownEditor extends IProps, ICodeMirror {
    prefixCls?: string;
    value?: string;
    height?: number;
    visible?: boolean;
    visibleEditor?: boolean;
    toolbars?: IToolBarProps['toolbars'];
    toolbarsMode?: IToolBarProps['toolbars'];
    previewProps?: MarkdownPreviewProps;
    options?: CodeMirror.EditorConfiguration;
}
export default function MarkdownEditor(props: IMarkdownEditor): JSX.Element;
