import _extends from "@babel/runtime/helpers/esm/extends";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import React, { useState, createRef, useRef, useEffect } from 'react';
import CodeMirror from './components/CodeMirror';
import MarkdownPreview from '@uiw/react-markdown-preview';
import ToolBar from './components/ToolBar';
import { getCommands, getModeCommands } from './commands';
import "./index.css";
export * from './commands';
export default function MarkdownEditor(props) {
  var _props$prefixCls = props.prefixCls,
      prefixCls = _props$prefixCls === void 0 ? 'md-editor' : _props$prefixCls,
      className = props.className,
      _onChange = props.onChange,
      _props$toolbars = props.toolbars,
      toolbars = _props$toolbars === void 0 ? getCommands() : _props$toolbars,
      _props$toolbarsMode = props.toolbarsMode,
      toolbarsMode = _props$toolbarsMode === void 0 ? getModeCommands() : _props$toolbarsMode,
      _props$visible = props.visible,
      visible = _props$visible === void 0 ? true : _props$visible,
      _props$visibleEditor = props.visibleEditor,
      visibleEditor = _props$visibleEditor === void 0 ? true : _props$visibleEditor,
      _props$previewProps = props.previewProps,
      previewProps = _props$previewProps === void 0 ? {} : _props$previewProps,
      codemirrorProps = _objectWithoutProperties(props, ["prefixCls", "className", "onChange", "toolbars", "toolbarsMode", "visible", "visibleEditor", "previewProps"]);

  var _useState = useState(props.value || ''),
      _useState2 = _slicedToArray(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  var codeMirror = /*#__PURE__*/createRef();
  var previewContainer = useRef();

  var _useState3 = useState(),
      _useState4 = _slicedToArray(_useState3, 2),
      editor = _useState4[0],
      setEditor = _useState4[1];

  var container = useRef(null);
  var containerEditor = useRef(null);
  useEffect(function () {
    if (codeMirror.current) {
      setEditor(codeMirror.current.editor);
    }
  }, [codeMirror.current]);
  var toolBarProps = {
    editor: editor,
    preview: previewContainer.current,
    container: container.current,
    containerEditor: containerEditor.current,
    editorProps: props
  };
  return /*#__PURE__*/React.createElement("div", {
    ref: container
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls || '', " ").concat(className || '')
  }, /*#__PURE__*/React.createElement(ToolBar, _extends({}, toolBarProps, {
    toolbars: toolbarsMode,
    mode: true
  })), /*#__PURE__*/React.createElement(ToolBar, _extends({}, toolBarProps, {
    toolbars: toolbars
  })), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-content")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-content-editor"),
    ref: containerEditor
  }, visibleEditor && /*#__PURE__*/React.createElement(CodeMirror, _extends({
    visibleEditor: visibleEditor
  }, codemirrorProps, {
    ref: codeMirror,
    onChange: function onChange(editor, data) {
      setValue(editor.getValue());
      _onChange && _onChange(editor, data, editor.getValue());
    }
  }))), /*#__PURE__*/React.createElement(MarkdownPreview, _extends({}, previewProps, {
    "data-visible": !!visible,
    className: "".concat(prefixCls, "-preview"),
    ref: function ref(instance) {
      if (instance && instance.mdp) {
        previewContainer.current = instance.mdp.current;
      }
    },
    source: value
  })))));
} 
//# sourceMappingURL=index.js.map